"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionButton = void 0;
var react_1 = __importDefault(require("react"));
var tooltip_1 = __importDefault(require("./antd/tooltip"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var ActionButton = function (props) {
    var doingIconColor = props.doingIconColor, doing = props.doing;
    var wrapperClassName = props.wrapperClassName
        ? props.wrapperClassName
        : "";
    var wrapperStyle = props.wrapperStyle ? props.wrapperStyle : {};
    var tooltipPlacement = props.tooltipPlacement
        ? props.tooltipPlacement
        : "bottom";
    var color = props.color ? props.color : primeobjects_helper_util_1.COLORS.GRAY;
    var iconColor = props.iconColor
        ? props.iconColor
        : primeobjects_helper_util_1.COLORS.GRAY;
    var textColor = props.textColor ? props.textColor : primeobjects_helper_util_1.COLORS.GRAY;
    var tooltipMouseLeaveDelay = props.tooltipMouseLeaveDelay
        ? props.tooltipMouseLeaveDelay
        : 0.1;
    var tooltipMouseEnterDelay = props.tooltipMouseEnterDelay
        ? props.tooltipMouseEnterDelay
        : 0.1;
    var renderActionButton = function () {
        return (react_1.default.createElement("div", { id: props.id, style: wrapperStyle, className: "flex rounded-md cursor-pointer ml-2 h-6 px-2 py-4 shadow hover:shadow-lg text-white justify-center items-center leading-none ".concat(wrapperClassName), onClick: function () { return props.onClick && props.onClick(); } },
            props.iconSrc && !doing && (react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { id: "".concat(props.id, "-svg"), src: props.iconSrc, size: 20, color: "".concat(iconColor["900"] ? iconColor["900"] : iconColor) })),
            props.doing && (react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { id: "".concat(props.id, "-doing-svg"), src: "/icons/platform/spinner.svg", size: 16, color: doingIconColor ? doingIconColor : primeobjects_helper_util_1.COLORS.WHITE, className: "spinner mr-1" })),
            props.text && (react_1.default.createElement("span", { className: "whitespace-nowrap ".concat(props.iconSrc ? "ml-1" : ""), style: {
                    color: "".concat(textColor["900"] ? textColor["900"] : textColor)
                } }, props.text))));
    };
    return props.tooltipText ? (react_1.default.createElement(tooltip_1.default, { color: color["500"], placement: tooltipPlacement, title: props.tooltipText, mouseEnterDelay: tooltipMouseEnterDelay, mouseLeaveDelay: tooltipMouseLeaveDelay }, renderActionButton())) : (renderActionButton());
};
exports.ActionButton = ActionButton;
exports.default = exports.ActionButton;
//# sourceMappingURL=action-button.js.map