"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StripeForm = exports.Stripe = void 0;
var react_1 = __importStar(require("react"));
var react_stripe_js_1 = require("@stripe/react-stripe-js");
var stripe_js_1 = require("@stripe/stripe-js");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var loading_1 = __importDefault(require("../sections/list/loading"));
var auth_call_api_1 = require("../context/auth-call-api");
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var util_1 = require("../util");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var lodash_1 = require("lodash");
// Make sure to call `loadStripe` outside of a component’s render to avoid
// recreating the `Stripe` object on every render.
// Publishable key
var stripePromise = (0, stripe_js_1.loadStripe)("pk_9xdrUeAVXvo55Dn0lcpCWcgZXvmCX");
var Stripe = function (props) {
    var id = props.id, paymentMethod = props.paymentMethod, currency = props.currency, attributeName = props.attributeName;
    var solution = (0, solution_1.useSolution)();
    var primaryColorName = (0, primary_color_1.usePrimaryColorName)(solution);
    var _a = (0, react_1.useState)(undefined), clientSecret = _a[0], setClientSecret = _a[1];
    var _b = (0, react_1.useState)(false), loading = _b[0], setLoading = _b[1];
    var _c = (0, react_1.useState)(""), error = _c[0], setError = _c[1];
    var _d = (0, react_1.useState)(undefined), triggerSubmit = _d[0], setTriggerSubmit = _d[1];
    (0, react_1.useEffect)(function () {
        if (id) {
            setLoading(true);
            (0, auth_call_api_1.callApi)(solution, (0, util_1.getApiEndpoint)(solution, "pay", "create-intent"), 
            //"http://localhost:3000/prod/create-intent", //`${solution.apis.pay}create-intent`,
            {
                id: id,
                attributeName: attributeName,
                currency: currency,
                paymentMethodTypes: paymentMethod
            }, "POST")
                .then(function (result) {
                if (!result.clientSecret) {
                    setError("Failed to create payment intention.");
                }
                else {
                    setClientSecret(result.clientSecret);
                }
            })
                .catch(function (error) {
                var _a, _b;
                console.error(error);
                setError("Failed to create payment intention. ".concat(((_a = error === null || error === void 0 ? void 0 : error.detail) === null || _a === void 0 ? void 0 : _a.reason) ? (_b = error === null || error === void 0 ? void 0 : error.detail) === null || _b === void 0 ? void 0 : _b.reason : ""));
            })
                .finally(function () {
                setLoading(false);
            });
        }
    }, [id]);
    var renderLoader = function () {
        if (!loading)
            return null;
        return (react_1.default.createElement(loading_1.default, { id: "stripe-section-loading", height: 60, count: 3, barHeight: 10, widthAdj: -30, style: { paddingLeft: 0, paddingRight: 0 } }));
    };
    var renderError = function () {
        if (!(0, primeobjects_helper_util_1.isNonEmptyString)(error))
            return null;
        return react_1.default.createElement("div", { className: "w-full text-red-600" }, error);
    };
    var onSubmit = function () {
        setTriggerSubmit(Date.now());
    };
    var onResize = function (width, height) {
        console.log({ width: width, height: height });
    };
    return (react_1.default.createElement(primeobjects_ui_web_basic_1.ResizeDetectorDiv, { className: "w-full flex flex-col", onDetect: onResize },
        renderLoader(),
        renderError(),
        !loading && !(0, primeobjects_helper_util_1.isNonEmptyString)(error) && clientSecret && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_stripe_js_1.Elements, { stripe: stripePromise, options: {
                    clientSecret: clientSecret,
                    appearance: {
                        theme: "stripe",
                        variables: {
                            focusBoxShadow: "none",
                            focusOutline: "none",
                            colorPrimary: "#333333",
                            colorBackground: "#ffffff",
                            colorText: "#333333",
                            colorDanger: "#df1b41",
                            spacingGridRow: "16px",
                            spacingGridColumn: "16px",
                            fontFamily: "-apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Helvetica Neue, Arial, Noto Sans, sans-serif, Apple Color Emoji, Segoe UI Emoji, Segoe UI Symbol, Noto Color Emoji;",
                            spacingUnit: "2px",
                            borderRadius: "0px",
                            fontSizeBase: "14px"
                            // See all possible variables below
                        }
                    }
                } },
                react_1.default.createElement(exports.StripeForm, __assign({}, props, { clientSecret: clientSecret, triggerSubmit: triggerSubmit }))),
            react_1.default.createElement("div", { className: "w-full mt-4" },
                react_1.default.createElement("div", { style: { maxWidth: 100 }, className: "flex rounded-md cursor-pointer h-6 px-2 py-4 shadow hover:shadow-lg text-white justify-center items-center leading-none bg-".concat(primaryColorName, "-500 hover:bg-").concat(primaryColorName, "-600"), onClick: onSubmit },
                    react_1.default.createElement("span", { className: "whitespace-nowrap text-white" }, "Pay Now")))))));
};
exports.Stripe = Stripe;
var StripeForm = function (props) {
    var paymentMethod = props.paymentMethod, clientSecret = props.clientSecret;
    var stripe = (0, react_stripe_js_1.useStripe)();
    var elements = (0, react_stripe_js_1.useElements)();
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(props.triggerSubmit)) {
            onClickSubmit();
        }
    }, [props.triggerSubmit]);
    var onClickSubmit = function () {
        // We don't want to let default form submission happen here,
        // which would refresh the page.
        if (!stripe || !elements) {
            // Stripe.js has not yet loaded.
            // Make sure to disable form submission until Stripe.js has loaded.
            return;
        }
        switch (paymentMethod) {
            case "wechat_pay": {
                stripe.confirmWechatPayPayment(clientSecret, {
                    payment_method_options: {
                        wechat_pay: {
                            client: "web"
                        }
                    }
                });
                break;
            }
            default: {
                stripe
                    .confirmPayment({
                    //`Elements` instance that was used to create the Payment Element
                    elements: elements,
                    redirect: "if_required",
                    confirmParams: {
                        return_url: props.returnUrl
                    }
                })
                    .then(function (result) {
                    if (result.error) {
                        // Show error to your customer (for example, payment details incomplete)
                        console.log(result.error.message);
                    }
                    else {
                        // Your customer will be redirected to your `return_url`. For some payment
                        // methods like iDEAL, your customer will be redirected to an intermediate
                        // site first to authorize the payment, then redirected to the `return_url`.
                    }
                });
            }
        }
    };
    return (react_1.default.createElement("form", null,
        react_1.default.createElement(react_stripe_js_1.PaymentElement, null)));
};
exports.StripeForm = StripeForm;
exports.default = exports.Stripe;
//# sourceMappingURL=stripe.js.map