"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrgModal = void 0;
var react_1 = __importDefault(require("react"));
var plain_modal_1 = require("primeobjects-ui-web-basic/build/cjs/controls/plain-modal");
var util_1 = require("../../util");
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lodash_1 = require("lodash");
var OrgForm = undefined;
var OrgModal = function (props) {
    if (!OrgForm) {
        console.log("Get global components in /modals/org-modal.tsx");
        OrgForm = (0, util_1.getGlobalComponent)("OrgForm", props.Form);
    }
    var contextStore = (0, primeobjects_ui_web_store_1.useContextStore)();
    var context = JSON.parse(contextStore.data);
    var organization = context.organization, solution = context.solution;
    var entity = (0, primeobjects_helper_util_1.getEntity)(solution, "Organization");
    var show = props.show, onClickClose = props.onClickClose, title = props.title;
    return (react_1.default.createElement(plain_modal_1.PlainModal, { title: title !== null && title !== void 0 ? title : "Organization Profile", show: show, onClickClose: onClickClose, width: 700 }, !(0, lodash_1.isNil)(OrgForm) && (react_1.default.createElement(OrgForm, { entity: entity, record: organization }))));
};
exports.OrgModal = OrgModal;
exports.default = exports.OrgModal;
//# sourceMappingURL=org-modal.js.map