//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect } from "react";
import PageHeadInternal from "../page/head";
import PageError from "./error";
import { checkPageError } from "./util";
import HeaderSectionInternal from "../sections/site-header";
import FooterSectionInternal from "../sections/site-footer";
import { setSolution } from "primeobjects-helper-ui/build/cjs/hooks/solution";
import { setAppTrack, isSSR } from "primeobjects-helper-util/build/cjs/core";
// import { ARTICLE_CSS } from "primeobjects-ui-web-basic/build/cjs/css/article-css";
// import CSS from "primeobjects-ui-web-store/build/cjs/css";
import { setLibTrack } from "primeobjects-helper-util";
import { getGlobalComponent } from "../util";
var PageHeadGlobal = undefined;
var HeaderSectionGlobal = undefined;
var FooterSectionGlobal = undefined;
export var SiteBasePage = function (props) {
    var _a, _b, _c, _d;
    if (!PageHeadGlobal) {
        console.log("Get global components in /page/site-base.tsx");
        PageHeadGlobal = getGlobalComponent("PageHead", PageHeadInternal);
        HeaderSectionGlobal = getGlobalComponent("HeaderSection", HeaderSectionInternal);
        FooterSectionGlobal = getGlobalComponent("FooterSection", FooterSectionInternal);
    }
    var solution = props.solution, footerClassName = props.footerClassName, footerStyle = props.footerStyle, 
    // currentContextSettings,
    appTrack = props.appTrack, libTrack = props.libTrack;
    var site = solution === null || solution === void 0 ? void 0 : solution.site;
    // const context = useCurrentContext(solution, {
    //     ...currentContextSettings,
    //     componentName: "/page/site-base.tsx"
    // });
    var PageHead = (_a = props.Head) !== null && _a !== void 0 ? _a : PageHeadGlobal;
    var HeaderSection = (_b = props.HeaderSection) !== null && _b !== void 0 ? _b : HeaderSectionGlobal;
    var FooterSection = (_c = props.FooterSection) !== null && _c !== void 0 ? _c : FooterSectionGlobal;
    var SSR = isSSR();
    useEffect(function () {
        if (!SSR)
            setSolution(solution);
        setAppTrack(appTrack == true);
        setLibTrack(libTrack == true);
    }, [solution.id]);
    //For now we only show navigation to sign in user
    var navigation = (_d = props.navigation) !== null && _d !== void 0 ? _d : site === null || site === void 0 ? void 0 : site.navigation;
    var breadcrumbItems = props.breadcrumbItems, children = props.children, headProps = props.headProps, siteName = props.siteName, siteLogo = props.siteLogo, siteOrgName = props.siteOrgName;
    var pageError = checkPageError(props);
    return !pageError ? (React.createElement(React.Fragment, null,
        React.createElement(PageHead, __assign({}, headProps)),
        React.createElement(HeaderSection, { solution: solution, navigation: navigation, className: "mb-0 sm:mb-0 md:mb-0 lg:mb-0", pages: breadcrumbItems, siteName: siteName, siteLogo: siteLogo }),
        React.createElement("div", { className: "min-w-full" }, children),
        React.createElement(FooterSection, { solution: solution, content: siteName ? siteName : site.title, copyright: site.copyright, businessName: siteOrgName ? siteOrgName : site.businessName, className: footerClassName, style: footerStyle }))) : (React.createElement(React.Fragment, null,
        React.createElement(PageError, { reason: pageError })));
};
export default SiteBasePage;
//# sourceMappingURL=site-base.js.map